<?php
/* --------------------------------------------------------------------- */
/* Plugin SPIP banip v1.1
/* 
/* Plugin simple de lute contre le spam dans les forums SPIP bas sur le 
/* bannissement de groupe d'adresse IP.
/* 
/* Licence GPL (c) 2008-2009 Benoit Laurent
/* --------------------------------------------------------------------- */
/**
 * 
 * Retourne l'adress IP du client
 *
 */
function ip_client() {
        return (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
}
/**
 * 
 * Teste l'apartenance d'une IP  un rseau
 *
 * http://ie.php.net/manual/fr/function.ip2long.php#92544
 * Usage :
 * ip_in_network("192.168.2.1","192.168.2.0",24); //true
 * ip_in_network("192.168.6.93","192.168.0.0",16); //true
 * ip_in_network("1.6.6.6","128.168.2.0",1); //false 
 *
 */
function ip_in_network($ip, $net_addr, $net_mask){
    if($net_mask <= 0){ return false; }
    $ip_binary_string = sprintf("%032b",ip2long($ip));
    $net_binary_string = sprintf("%032b",ip2long($net_addr));
    return (substr_compare($ip_binary_string,$net_binary_string,0,$net_mask) === 0);
}


/**
 * 
 * Dtermine si l'adresse pass bannie
 *
 */
function bannirIp($ip) {
    $lignes = file(_DIR_PLUGIN_BANIP.'ip_black_list.txt');
    foreach ($lignes as $ligne)
    {
        $entree = explode('/', $ligne);
        if(ip_in_network($ip, $entree[0], $entree[1])) {return true;}
    }
    
    //spip_log("banip - Position IP, $ip_group : $pos", "plugin_banip");
    return false;
 
}
/**
 * 
 * Dtermine si le mail pass est bannie
 *
 */
function bannirMail($mail) {
    $pos = strpos(file_get_contents(_DIR_PLUGIN_BANIP.'mail_black_list.txt'), $mail);
    //spip_log("banip - Position mail $mail : $pos", "plugin_banip");
    return $pos === false ? false : true;
 
}
?>
